angular.module('manageProfilesApp', [
    'ngRoute',
    'manageProfiles',
    'wemServices',
    'wemDirectives'
])
    .config(['$routeProvider',
        function ($routeProvider) {
            $routeProvider.
                when('/profiles', {
                    templateUrl: ManagersContext.localTemplatesPath + '/profiles/profiles-list.html',
                    controller: 'ManageProfileSummaryCtrl'
                }).
                when('/profile/:profileId', {
                    templateUrl: ManagersContext.localTemplatesPath + '/profiles/profile-view.html',
                    controller: 'ManageProfileCtrl',
                    resolve: {
                        // resolve profile here to avoid async issue using deferred API
                        "profile": function ($q, $route, profileService) {
                            var profile = $q.defer();
                            profileService.getProfile($route.current.params.profileId).success(function (profileData) {
                                profile.resolve(profileData);
                            });
                            return profile.promise;
                        }
                    }
                }).
                when('/profile/:profileId/:sessionId', {
                    templateUrl: ManagersContext.localTemplatesPath + '/profiles/profile-session.html',
                    controller: 'ManageSessionCtrl'
                }).
                when('/personas', {
                    templateUrl: ManagersContext.localTemplatesPath + '/profiles/personas-list.html'
                }).
                when('/persona/:profileId', {
                    templateUrl: ManagersContext.localTemplatesPath + '/profiles/persona-view.html',
                    controller: 'ManageProfileCtrl',
                    resolve: {
                        // resolve profile here to avoid async issue using deferred API
                        "profile": function ($q, $route, profileService) {
                            var profile = $q.defer();
                            profileService.getProfile($route.current.params.profileId, 'personas').success(function (profileData) {
                                profile.resolve(profileData);
                            });
                            return profile.promise;
                        }
                    }
                }).
                when('/persona/:profileId/:sessionId', {
                    templateUrl: ManagersContext.localTemplatesPath + '/profiles/profile-session.html',
                    controller: 'ManageSessionCtrl'
                }).
                when('/newPersona', {
                    templateUrl: ManagersContext.localTemplatesPath + '/profiles/persona-view.html',
                    controller: 'ManageProfileCtrl',
                    resolve: {
                        // resolve profile here to avoid async issue using deferred API
                        "profile": function () {
                            return {
                                "itemId": "newPersona",
                                "itemType": "persona",
                                "properties": {
                                },
                                "systemProperties": {
                                },
                                "segments": [],
                                "scores": {}
                            }
                        }
                    }
                }).otherwise({
                    redirectTo: angular.isDefined(ManagersContext.wemDefaultRoute) ? ('/' + ManagersContext.wemDefaultRoute) : '/profiles'
                });
        }]);
