<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>

<script type="text/javascript">
<c:set var="pageVariantFallback" value="${currentNode}"/>
<c:if test="${not empty currentNode.properties['wem:fallbackVariant'].string}">
<%-- Fallback variant is explicitly specified --%>
<c:set var="pageVariantFallback" value="${currentNode.properties['wem:fallbackVariant'].node}"/>
</c:if>

<c:set var="pageVariantStrategy" value="${currentNode.properties['wem:personalizationStrategy'].string}"/>
<c:if test="${empty strategy}">
<c:set var="pageVariantStrategy" value="priority"/>
</c:if>

var pagePersonalization = {
    filters: {
    <c:forEach items="${pageVariants}" var="subchild" varStatus="varStatus">
    '${subchild.identifier}' : {
    <c:set var="hasfilter" value="${not empty subchild.properties['wem:jsonFilter'].string}" />
    <c:set var="subChildFilter" value=""/>
    <c:if test="${hasfilter}">
    <c:set var="subChildFilter" value="{\"appliesOn\":[{}],\"condition\":${subchild.properties['wem:jsonFilter'].string}}"/>
    </c:if>
    "filter": {"filterid":"${subchild.identifier}","filters":[${subChildFilter}]},
    "variantWrapper": "${currentNode.identifier}",
        "variantWrapperPath": "${currentNode.path}",
        "variantPath": "${subchild.path}",
        "pagePath": "${jcr:getParentOfType(currentNode,"jnt:page").path}",
        "content": "${varStatus.index == 0 ? '' : subchild.name}",
        "priority": -${varStatus.index + 1}
}${!varStatus.last ? ',' : ''}
    </c:forEach>
    },
    identifer:'${currentNode.identifier}',
    strategy:'${pageVariantStrategy}',
    fallback:'${pageVariantFallback.identifier}',
    wemActiveVariant: '${param['wemActiveVariant']}'
};


</script>