<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="wem" uri="http://www.jahia.org/tags/wem" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="subchild" type="org.jahia.services.content.JCRNodeWrapper"--%>

<template:include view="editToolbar">
    <template:param name="arrowColor" value="blue"/>
    <template:param name="editableVariants" value="${editableModule}"/>
</template:include>

<c:if test="${renderContext.previewMode or renderContext.liveMode}">
    <c:if test="${not empty currentNode.properties['wem:fallbackVariant'].string}">
        <%-- Fallback variant is explicitly specified --%>
        <c:set var="fallbackVariant" value="${currentNode.properties['wem:fallbackVariant'].node}"/>
    </c:if>
    <c:set var="personalizationActive" value="${wem:isPersonalizationActive(currentNode)}"/>
    <c:set var="ajaxRender" value="${empty currentNode.properties['wem:ajaxRender'] or currentNode.properties['wem:ajaxRender'].boolean}"/>
    
    <c:if test="${personalizationActive}">
        <template:addResources type="javascript" resources="jquery.min.js"/>
        <c:set var="elementID" value="wempersonalized-${currentNode.identifier}" />
        <c:set var="parsedId" value="${fn:replace(currentNode.identifier,'-','_')}"/>


        <div id="${elementID}">
            <c:if test="${not ajaxRender}">
            <c:forEach items="${moduleMap.variants}" var="subchild" varStatus="st">
            <div style="display: none" id="wem${parsedId}${st.index}">
                <template:module node="${subchild}" nodeTypes="${requestScope[constraints] == 'jmix:droppableContent' ? '' : requestScope[constraints]}" />
            </div>
            </c:forEach>
            </c:if>
        </div>

        <script type="text/javascript">
            (function(){
                var filters = {
                <c:forEach items="${moduleMap.variants}" var="subchild" varStatus="varStatus">
                '${subchild.identifier}' : {
                    <c:set var="hasfilter" value="${not empty subchild.properties['wem:jsonFilter'].string}" />
                    <c:set var="subChildFilter" value=""/>
                    <c:if test="${hasfilter}">
                        <c:set var="subChildFilter" value="{\"appliesOn\":[{}],\"condition\":${subchild.properties['wem:jsonFilter'].string}}"/>
                    </c:if>
                    "filter": {"filterid":"${subchild.identifier}","filters":[${subChildFilter}]},
                    "variantWrapper": "${currentNode.identifier}",
                    "variantWrapperPath": "${currentNode.path}",
                    "variantPath": "${subchild.path}",
                    "pagePath": "${jcr:getParentOfType(currentNode,"jnt:page").path}",
                    <c:if test="${not ajaxRender}">
                    "content": "wem${parsedId}${varStatus.index}",
                    </c:if>
                    <c:if test="${ajaxRender}">
                    "content": "<c:url value="${url.base}${functions:escapePath(subchild.path)}.${functions:default(subchild.properties['j:view'].string, 'default')}.html.ajax"/>",
                    </c:if>
                    "priority": -${varStatus.index + 1}
                }${!varStatus.last ? ',' : ''}
                </c:forEach>
                };

                <c:set var="strategy" value="${currentNode.properties['wem:personalizationStrategy'].string}"/>
                <c:if test="${empty strategy}">
                <c:set var="strategy" value="priority"/>
                </c:if>

                if(window.wem) {
                    window.wem.registerPersonalization(filters,'${strategy}','${elementID}', '${not empty fallbackVariant ? fallbackVariant.identifier : ""}', ${ajaxRender}, null);
                } else {
                    <c:if test="${not ajaxRender}">
                        document.getElementById(filters['${fallbackVariant.identifier}'].content).style.display = '';
                    </c:if>
                    <c:if test="${ajaxRender}">
                        var xhr = new XMLHttpRequest();
                        var finished = false;
                        xhr.onabort = xhr.onerror = function xhrError() {
                            finished = true;
                        };

                        xhr.onreadystatechange = function xhrStateChange() {
                            if (xhr.readyState === 4 && !finished) {
                                finished = true;
                                try {
                                    document.getElementById('${elementID}').innerHTML = xhr.responseXML.getElementsByTagName('body')[0].innerHTML;
                                } catch (e) {
                                    console.log(e);
                                }
                            }
                        };

                        xhr.open('GET', '<c:url value="${url.base}${functions:escapePath(fallbackVariant.path)}.${functions:default(fallbackVariant.properties['j:view'].string, 'default')}.html.ajax"/>');
                        xhr.responseType = 'document';
                        xhr.send();
                    </c:if>
                    console.log("No wem available in page, can't register personalization.")
                }
            })();
        </script>
    </c:if>
    <c:if test="${not personalizationActive}">
        <c:if test="${empty fallbackVariant && not empty moduleMap.variants}">
            <%-- Fallback variant is not explicitly specified, take the first variant in the list --%>
            <c:forEach items="${moduleMap.variants}" var="subchild" end="0">
                <c:set var="fallbackVariant" value="${subchild}"/>
            </c:forEach>
        </c:if>
        <c:if test="${not empty fallbackVariant}">
            <template:module node="${fallbackVariant}"/>
        </c:if>
    </c:if>
</c:if>